<template lang="pug">
.vc-table-search
	.vc-table-search__search
		b-field.vc-table-search__search-field(grouped)
			b-input.control.vc-table-search__search-input(expanded :placeholder="searchPlaceholder" type="search" icon="magnify" v-model="searchInput")
			template(v-if="$slots.action")
				.control.vc-table-search__search-action
					slot(name="action")
		.vc-table-search__search-action-mobile
			slot(name="action")
	vc-table(v-bind="$attrs" v-on="$listeners" :items="filteredItems")
		slot(slot="bottom-left" name="bottom-left")
</template>
<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';

@Component<Listagem>({
	inheritAttrs: false,
	props: {
		search: { type: [Array, String], required: true },
		searchOptions: Object,
		searchPlaceholder: { type: String, default: 'Digite para searchr' },
		items: Array,
	},
})
export default class Listagem extends Vue {
	items!: Array<any>;
	search!: Array<string> | string;
	searchOptions!: any;
	searchInput: string = '';

	/// Get the filtered itens
	get filteredItems() {
		if (this.fuse && this.searchInput.length > 0) return this.fuse.instance.search(this.searchInput);
		return this.items;
	}

	/// Get the fuse instance
	get fuse() {
		if (!this.search || !this.items) return null;
		// @ts-ignore
		const Fuse = this.$vueComponentsOptions.libraries.Fuse;
		if (!Fuse) return null;
		const instance = new Fuse(this.items, {
			shouldSort: true,
			threshold: 0.6,
			location: 0,
			distance: 100,
			maxPatternLength: 32,
			minMatchCharLength: 1,
			keys: typeof this.search === 'string' ? [this.search] : [...this.search],
			...this.searchOptions,
		});
		return Object.freeze({ instance });
	}
}
</script>
<style lang="scss" scoped>
.vc-table-search__search {
	margin-bottom: 1rem;
	.vc-table-search__search-action-mobile {
		margin-bottom: 1rem;
	}
	.control.vc-table-search__search-input {
		margin-right: 0;
	}
	.vc-table-search__search-action {
		display: none;
	}

	@include mq(tablet) {
		.vc-table-search__search-action-mobile {
			display: none;
		}
		.vc-table-search__search-action {
			display: block;
		}
		.control.vc-table-search__search-input {
			margin-right: 0.75rem;
		}
	}
}
</style>
